(function() {
	'use strict';

	angular
		.module('ngApp.controllers', [])
		.controller('MainCtrl', MainController)
		.controller('NavCtrl', NavController)
		.controller('searchCtrl', searchController);

	MainController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', '$ionicPopover', '$ionicConfig'];
	function MainController($scope, $rootScope, $state, $stateParams, $ionicPopover, $ionicConfig) {
		$rootScope.$state = $state;
		$scope.$state = $state.current;
		$scope.params = $stateParams;
		var theme = appsetting.theme ? appsetting.theme : 'default';
		var fontfamily = appsetting.fontFamily ? appsetting.fontFamily : 'IRANSans';
		$rootScope.appsetting = { theme : theme , fontfamily : fontfamily};

		var template = '<ion-popover-view><ion-content class="padding"><button ng-if="share" ng-click="shareIt()" class="button button-block button-clear button-light icon-right ion-share" title="global.share">اشتراک گذاری مطلب</button><div class="button-bar"><button class="button button-clear button-light big" onclick="increaseFontSize(15)">چ</button><button class="button button-clear button-light small" onclick="increaseFontSize(-15)">چ</button></div><div class="button-bar" style="margin-top:10px"><button class="button button-clear button-light big" onclick="increaseZoomLevel(10)"><i class="icon ion-search"></i></button><button class="button button-clear button-light small" onclick="increaseZoomLevel(-10)"><i class="icon ion-search"></i></button></div><div class="popover-row-dots row"><div class="col"><button class="popover-dot-white popover-dot" ng-class="appsetting.theme == \'default\' ? \'selected\' : \'\'" ng-click="changeColor(\'default\')"></button></div><div class="col"><button class="popover-dot-tan popover-dot" ng-class="appsetting.theme == \'tanTheme\' ? \'selected\' : \'\'" ng-click="changeColor(\'tanTheme\')"></button></div><div class="col"><button class="popover-dot-grey popover-dot" ng-class="appsetting.theme == \'greyTheme\' ? \'selected\' : \'\'" ng-click="changeColor(\'greyTheme\')"></button></div></div>'
					+ '<label class="item item-radio"><input type="radio" name="font" value="IRANSans" ng-model="appsetting.fontfamily" ng-click="changeFontFamily(\'IRANSans\')"><div class="item-content" style="font-family:IRANSans">ایران سنس</div><i class="radio-icon ion-checkmark"></i></label>'
					+ '<label class="item item-radio"><input type="radio" name="font" value="yekan" ng-model="appsetting.fontfamily" ng-click="changeFontFamily(\'yekan\')"><div class="item-content" style="font-family:yekan">یکان</div><i class="radio-icon ion-checkmark"></i></label>'
					+ '<label class="item item-radio"><input type="radio" name="font" value="tahoma" ng-model="appsetting.fontfamily" ng-click="changeFontFamily(\'tahoma\')"><div class="item-content" style="font-family:tahoma">tahoma</div><i class="radio-icon ion-checkmark"></i></label>'
				+ '</ion-content></ion-popover-view>';

		$scope.popover = $ionicPopover.fromTemplate(template, {
			scope: $scope
		});

		$scope.openSetting = function($event, options) {
			$scope.share = (options && options.share) ? true : false;
			if($scope.share) $scope.sharecontent = $(options.contentSelector).text();
			$scope.popover.show($event);
		}

		$scope.shareIt = function() {
			var tmp = document.createElement("DIV");
			tmp.innerHTML = $scope.sharecontent;
			window.plugins.socialsharing.share(getTextFromNode(tmp,true));
		}

		$scope.shareThisElement = function(selector) {
			var text = document.querySelector(selector).innerText;
			window.plugins.socialsharing.share(null , text, null, null);
		}

		$scope.changeColor = function(color) {
			$rootScope.appsetting.theme = color;
			appsetting['theme'] = color;
			saveSetting();
		}

		$scope.changeFontFamily = function(fontfamily) {
			$rootScope.appsetting.fontfamily = fontfamily;
			appsetting['fontFamily'] = fontfamily;
			saveSetting();
		}

		var sharePopoverTemplate = '<ion-popover-view style="width: 155px;height: 70px;"><ion-content class="padding">'+
				'<a href="https://telegram.me/share/url?url={{ shareUrl }}&text={{ shareTitle }}" target="_blank"				class="button button-icon icon ion-paper-airplane"></a>'+
				'<a href="https://wa.me/?text={{ shareTitle }} {{ shareUrl }}" target="_blank" class="button button-icon icon ion-social-whatsapp"></a>'+
				'<a href="https://twitter.com/intent/tweet?text={{ shareTitle }}&source=sharethiscom&related=sharethis&url={{ shareUrl }}" target="_blank" class="button button-icon icon ion-social-twitter"></a>'+
				'<a href="https://www.facebook.com/sharer.php?u={{ shareUrl }}" target="_blank" class="button button-icon icon ion-social-facebook"></a>'+
				'</ion-content></ion-popover-view>';

		$scope.sharePopover = $ionicPopover.fromTemplate(sharePopoverTemplate, {
			scope: $scope
		});

		$rootScope.webAppShare = function (event, title, url) {
			$scope.shareTitle = title;
			$scope.shareUrl = encodeURI(url);
			$scope.sharePopover.show(event);
		}
	}

	NavController.$inject = ['$scope', '$rootScope', '$ionicSideMenuDelegate', '$ionicModal'];
	function NavController($scope, $rootScope, $ionicSideMenuDelegate, $ionicModal) {
		$scope.showMenu = function () {
			$ionicSideMenuDelegate.toggleLeft();
		};
		$scope.showRightMenu = function () {
			$ionicSideMenuDelegate.toggleRight();
		};
		$scope.isPurchased = function (product) {
			return $rootScope[product] ? 'ng-hide' : 'ng-show';
		};
		
	}
	
	searchController.$inject = ['$stateParams'];
	function searchController($stateParams) {
		if($stateParams.search){
			document.getElementById("searchable").innerHTML = doHighlight(document.getElementById("searchable").innerHTML,$stateParams.search);
		}
	}

})();
